/*
    JV Library
    Copyright (C) 2014  Jouko Juhani Virtanen

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _AtomCode_included
#define _AtomCode_included

const int NumAtomTypes1=433;
const int NumAtomTypes2=10;

const int UNK_ATOM_TYPE=0;
const int HT=1;
const int OT=2;
const int ALA_N=3;
const int ALA_HN=4;
const int ALA_CA=5;
const int ALA_HA=6;
const int ALA_CB=7;
const int ALA_HB=8;
const int ALA_C=9;
const int ALA_O=10;
const int ARG_N=11;
const int ARG_HN=12;
const int ARG_CA=13;
const int ARG_HA=14;
const int ARG_CB=15;
const int ARG_HB=16;
const int ARG_CG=17;
const int ARG_HG=18;
const int ARG_CD=19;
const int ARG_HD=20;
const int ARG_NE=21;
const int ARG_HE=22;
const int ARG_CZ=23;
const int ARG_NH=24;
const int ARG_HH=25;
const int ARG_C=26;
const int ARG_O=27;
const int ASN_N=28;
const int ASN_HN=29;
const int ASN_CA=30;
const int ASN_HA=31;
const int ASN_CB=32;
const int ASN_HB=33;
const int ASN_CG=34;
const int ASN_OD=35;
const int ASN_ND=36;
const int ASN_HD=37;
const int ASN_C=38;
const int ASN_O=39;
const int ASP_N=40;
const int ASP_HN=41;
const int ASP_CA=42;
const int ASP_HA=43;
const int ASP_CB=44;
const int ASP_HB=45;
const int ASP_CG=46;
const int ASP_OD=47;
const int ASP_ND=48;
const int ASP_HD=49;
const int ASP_C=50;
const int ASP_O=51;
const int CYS_N=52;
const int CYS_HN=53;
const int CYS_CA=54;
const int CYS_HA=55;
const int CYS_CB=56;
const int CYS_HB=57;
const int CYS_SG=58;
const int CYS_HG=59;
const int CYS_C=60;
const int CYS_O=61;
const int GLU_N=62;
const int GLU_HN=63;
const int GLU_CA=64;
const int GLU_HA=65;
const int GLU_CB=66;
const int GLU_HB=67;
const int GLU_CG=68;
const int GLU_HG=69;
const int GLU_CD=70;
const int GLU_OE=71;
const int GLU_C=72;
const int GLU_O=73;
const int GLN_N=74;
const int GLN_HN=75;
const int GLN_CA=76;
const int GLN_HA=77;
const int GLN_CB=78;
const int GLN_HB=79;
const int GLN_CG=80;
const int GLN_HG=81;
const int GLN_CD=82;
const int GLN_OE=83;
const int GLN_NE=84;
const int GLN_HE=85;
const int GLN_C=86;
const int GLN_O=87;
const int GLY_N=88;
const int GLY_HN=89;
const int GLY_CA=90;
const int GLY_HA=91;
const int GLY_C=92;
const int GLY_O=93;
const int HIS_N=94;
const int HIS_HN=95;
const int HIS_CA=96;
const int HIS_HA=97;
const int HIS_CB=98;
const int HIS_HB=99;
const int HIS_ND=100;
const int HIS_HD1=101;
const int HIS_CG=102;
const int HIS_CE=103;
const int HIS_HE=104;
const int HIS_NE=105;
const int HIS_CD=106;
const int HIS_HD2=107;
const int HIS_C=108;
const int HIS_O=109;
const int ILE_N=110;
const int ILE_HN=111;
const int ILE_CA=112;
const int ILE_HA=113;
const int ILE_CB=114;
const int ILE_HB=115;
const int ILE_CG=116;
const int ILE_HG=117;
const int ILE_CD=118;
const int ILE_HD=119;
const int ILE_C=120;
const int ILE_O=121;
const int LEU_N=122;
const int LEU_HN=123;
const int LEU_CA=124;
const int LEU_HA=125;
const int LEU_CB=126;
const int LEU_HB=127;
const int LEU_CG=128;
const int LEU_HG=129;
const int LEU_CD=130;
const int LEU_CD1=131;
const int LEU_CD2=132;
const int LEU_HD=133;
const int LEU_HD1=134;
const int LEU_HD2=135;
const int LEU_C=136;
const int LEU_O=137;
const int LYS_N=138;
const int LYS_HN=139;
const int LYS_CA=140;
const int LYS_HA=141;
const int LYS_CB=142;
const int LYS_HB=143;
const int LYS_CG=144;
const int LYS_HG=145;
const int LYS_CD=146;
const int LYS_HD=147;
const int LYS_CE=148;
const int LYS_HE=149;
const int LYS_NZ=150;
const int LYS_HZ=151;
const int LYS_C=152;
const int LYS_O=153;
const int MET_N=154;
const int MET_HN=155;
const int MET_CA=156;
const int MET_HA=157;
const int MET_CB=158;
const int MET_HB=159;
const int MET_CG=160;
const int MET_HG=161;
const int MET_SD=162;
const int MET_CE=163;
const int MET_HE=164;
const int MET_C=165;
const int MET_O=166;
const int PHE_N=167;
const int PHE_HN=168;
const int PHE_CA=169;
const int PHE_HA=170;
const int PHE_CB=171;
const int PHE_HB=172;
const int PHE_CG=173;
const int PHE_CD=174;
const int PHE_HD=175;
const int PHE_CE=176;
const int PHE_HE=177;
const int PHE_CZ=178;
const int PHE_HZ=179;
const int PHE_C=180;
const int PHE_O=181;
const int PRO_N=182;
const int PRO_CD=183;
const int PRO_HD=184;
const int PRO_CA=185;
const int PRO_HA=186;
const int PRO_CB=187;
const int PRO_HB=188;
const int PRO_CG=189;
const int PRO_HG=190;
const int PRO_C=191;
const int PRO_O=192;
const int SER_N=193;
const int SER_HN=194;
const int SER_CA=195;
const int SER_HA=196;
const int SER_CB=197;
const int SER_HB=198;
const int SER_OG=199;
const int SER_HG=200;
const int SER_C=201;
const int SER_O=202;
const int THR_N=203;
const int THR_HN=204;
const int THR_CA=205;
const int THR_HA=206;
const int THR_CB=207;
const int THR_HB=208;
const int THR_OG=209;
const int THR_HG1=210;
const int THR_CG=211;
const int THR_HG2=212;
const int THR_C=213;
const int THR_O=214;
const int TRP_N=215;
const int TRP_HN=216;
const int TRP_CA=217;
const int TRP_HA=218;
const int TRP_CB=219;
const int TRP_HB=220;
const int TRP_CG=221;
const int TRP_CD1=222;
const int TRP_HD=223;
const int TRP_NE=224;
const int TRP_HE1=225;
const int TRP_CE2=226;
const int TRP_CD2=227;
const int TRP_CE3=228;
const int TRP_HE3=229;
const int TRP_CZ3=230;
const int TRP_HZ3=231;
const int TRP_CZ2=232;
const int TRP_HZ2=233;
const int TRP_CH2=234;
const int TRP_HH=235;
const int TRP_C=236;
const int TRP_O=237;
const int TYR_N=238;
const int TYR_HN=239;
const int TYR_CA=240;
const int TYR_HA=241;
const int TYR_CB=242;
const int TYR_HB=243;
const int TYR_CG=244;
const int TYR_CD=245;
const int TYR_HD=246;
const int TYR_CE=247;
const int TYR_HE=248;
const int TYR_CZ=249;
const int TYR_OH=250;
const int TYR_HH=251;
const int TYR_C=252;
const int TYR_O=253;
const int VAL_N=254;
const int VAL_HN=255;
const int VAL_CA=256;
const int VAL_HA=257;
const int VAL_CB=258;
const int VAL_HB=259;
const int VAL_CG=260;
const int VAL_HG=261;
const int VAL_C=262;
const int VAL_O=263;
const int HSP_N=264;
const int HSP_HN=265;
const int HSP_CA=266;
const int HSP_HA=267;
const int HSP_CB=268;
const int HSP_HB=269;
const int HSP_CD=270;
const int HSP_HD2=271;
const int HSP_CG=272;
const int HSP_NE=273;
const int HSP_HE2=274;
const int HSP_ND=275;
const int HSP_HD1=276;
const int HSP_CE=277;
const int HSP_HE1=278;
const int HSP_C=279;
const int HSP_O=280;
const int HEM_FE=281;
const int HEM_NA=282;
const int HEM_NB=283;
const int HEM_NC=284;
const int HEM_ND=285;
const int HEM_C1=286;
const int HEM_C2=287;
const int HEM_C3=288;
const int HEM_C4=289;
const int HEM_CH=290;
const int HEM_HA=291;
const int HEM_HB=292;
const int HEM_HC=293;
const int HEM_HD=294;
const int HEM_CM=295;
const int HEM_HM=296;
const int HEM_CA=297;
const int HEM_CB=298;
const int HEM_CG=299;
const int HEM_O1=300;
const int HEM_O2=301;
const int GUA_P=302;
const int GUA_O1P=303;
const int GUA_O2P=304;
const int GUA_O5_=305;
const int GUA_C5_=306;
const int GUA_H5_=307;
const int GUA_H5__=308;
const int GUA_C4_=309;
const int GUA_H4_=310;
const int GUA_O4_=311;
const int GUA_C1_=312;
const int GUA_H1_=313;
const int GUA_N9=314;
const int GUA_C8=315;
const int GUA_H8=316;
const int GUA_N7=317;
const int GUA_C5=318;
const int GUA_C6=319;
const int GUA_O6=320;
const int GUA_N1=321;
const int GUA_H1=322;
const int GUA_C2=323;
const int GUA_N2=324;
const int GUA_H21=325;
const int GUA_H22=326;
const int GUA_N3=327;
const int GUA_C4=328;
const int GUA_C3_=329;
const int GUA_H3_=330;
const int GUA_C2_=331;
const int GUA_H2__=332;
const int GUA_O2_=333;
const int GUA_H2_=334;
const int GUA_O3_=335;
const int URA_P=336;
const int URA_O1P=337;
const int URA_O2P=338;
const int URA_O5_=339;
const int URA_C5_=340;
const int URA_H5_=341;
const int URA_H5__=342;
const int URA_C4_=343;
const int URA_H4_=344;
const int URA_O4_=345;
const int URA_C1_=346;
const int URA_H1_=347;
const int URA_N1=348;
const int URA_C6=349;
const int URA_H6=350;
const int URA_C5=351;
const int URA_H5=352;
const int URA_C4=353;
const int URA_O4=354;
const int URA_N3=355;
const int URA_H3=356;
const int URA_C2=357;
const int URA_O2=358;
const int URA_C3_=359;
const int URA_H3_=360;
const int URA_C2_=361;
const int URA_H2__=365;
const int URA_O2_=366;
const int URA_H2_=367;
const int URA_O3_=368;
const int ADE_P=369;
const int ADE_O1P=370;
const int ADE_O2P=371;
const int ADE_O5_=372;
const int ADE_C5_=373;
const int ADE_H5_=374;
const int ADE_H5__=375;
const int ADE_C4_=376;
const int ADE_H4_=377;
const int ADE_O4_=378;
const int ADE_C1_=379;
const int ADE_H1_=380;
const int ADE_N9=381;
const int ADE_C8=382;
const int ADE_H8=383;
const int ADE_N7=384;
const int ADE_C5=385;
const int ADE_C6=386;
const int ADE_N6=387;
const int ADE_H61=388;
const int ADE_H62=389;
const int ADE_N1=390;
const int ADE_C2=391;
const int ADE_H2=392;
const int ADE_N3=393;
const int ADE_C4=394;
const int ADE_C3_=395;
const int ADE_H3_=396;
const int ADE_C2_=397;
const int ADE_H2__=398;
const int ADE_O2_=399;
const int ADE_H2_=400;
const int ADE_O3_=401;
const int CYT_P=402;
const int CYT_O1P=403;
const int CYT_O2P=404;
const int CYT_O5_=405;
const int CYT_C5_=406;
const int CYT_H5_=407;
const int CYT_H5__=408;
const int CYT_C4_=409;
const int CYT_H4_=410;
const int CYT_O4_=411;
const int CYT_C1_=412;
const int CYT_H1_=413;
const int CYT_N1=414;
const int CYT_C6=415;
const int CYT_H6=416;
const int CYT_C5=417;
const int CYT_H5=418;
const int CYT_C4=419;
const int CYT_N4=420;
const int CYT_H41=421;
const int CYT_H42=422;
const int CYT_N3=423;
const int CYT_C2=424;
const int CYT_O2=425;
const int CYT_C3_=426;
const int CYT_H3_=427;
const int CYT_C2_=428;
const int CYT_H2__=429;
const int CYT_O2_=430;
const int CYT_H2_=431;
const int CYT_O3_=432;

const int HC=0;
const int HN=1;
const int HO=2;
const int HS=3;
const int C=4;
const int N=5;
const int O=6;
const int S=7;
const int FE=8;
const int P=9;
#endif
