/*
    JV Library
    Copyright (C) 2014  Jouko Juhani Virtanen

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _Constants_included_
#define _Constants_included_

# include "TypeDef.h"

const Real pi=3.1415926535389793;
const long double LongPi=3.14159265358979323846264338327950288419716939937510;
const Real pi32=5.568327997;
const Real packing=1.105339; //(3*2^0.5/pi)^(1/3)
const Real GaussianToHardSphere=1.099543; //(4/(3*pi^0.5))^(1/3)
const Real HardSphereToGaussianSphere=1.0/GaussianToHardSphere;
const Real CubeToSphere=0.62035; //(3/(4pi))^(1/3)
const Real TWO_TO_ONE_THIRD=1.259921; //2^(1/3)
const Real INV_TWO_TO_ONE_THIRD=1.0/TWO_TO_ONE_THIRD;
const Real INV_TWO_PI=0.159154943; //11/(2*pi)
const Real RAD_TO_DEGREE=360.0/(2.0*pi);
const Real DEGREE_TO_RAD=2.0*pi/360.0;
const Real Kb=1.3806504e-23;
const Real NA=6.02214179e23;
const int InProtein=0;
const int InHydrationShell=1;
const int InSolution=2;

const int HYDROPHOBIC=0;
const int HYDROPHILIC=1;

const int HOT=0;
const int COLD=1;
const int NEITHER=2;

const int X=0;
const int Y=1;
const int Z=2;

const int PHI=0;
const int PSI=1;
const int OMEGA=2;

const int HELIX=0;
const int PP2=1;
const int BETA=2;
const int LEFT_HANDED_HELIX=3;
const int OTHER=4;
const int FORBIDDEN=5;

const int NUM_RES_TYPES=20;

const Real UNK_REAL=-666666.0;
const int UNK_INT=-666666;

const string ALPHABET="ABCDEFGHIJKLMNOPQRSTUVWXYZ";

#endif
