/*
    JV Library
    Copyright (C) 2014  Jouko Juhani Virtanen

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _LocalMove_include_
#define _LocalMove_include_
Real calcRestraintEnergy(ProteinStruct &Protein, vector<AtomStruct> &restraintAtoms, vector<int> &restraintAtomsIndex);
Real calcRestraintEnergy(vector<Real> &dihedral, ProteinStruct &Protein, vector<AtomStruct> &restraintAtoms, vector<int> &restraintAtomsIndex, vector<int> &variableDihedrals);
//Real calcRestraintEnergy(vector<Real> dihedral, MinimizeRestraintStruct args);
void setVariableDihedrals(vector<Real> &dihedrals, vector<int> &variableDihedrals, vector<Real> &protDihedrals);
void minimizeRestraints(ProteinStruct &Protein , vector<AtomStruct> &restraintAtoms, vector<int> restraintAtomsIndex, vector<int> &variableDihedrals);
void getRestraintAtoms(vector<AtomStruct> &Atoms, vector<AtomStruct> &restraintAtoms, vector<int> &restraintAtomsIndex, int residue, int angleType);
Real localMove(ProteinStruct &Protein, int residue, int angleType, Real dAngle);
void getBondAtoms(vector<AtomStruct> &Atoms, int index, int &atom1, int &atom2);
void allignBondWithXAxis(ProteinStruct &Protein, vector<AtomStruct> &restraintAtoms, int index);
Real calcRestraintDerivative(AtomStruct &Atom1, AtomStruct &Atom2);
Real calcRestraintDerivative(AtomStruct &mobileAtom, AtomStruct &restraintAtom, AtomStruct &bondAtom, VectorStruct &bond);
Real calcRestraintDerivative(ProteinStruct &Protein, vector<AtomStruct> &restraintAtoms, vector<int> &restraintAtomsIndex, int &variableDihedral, int &atom1, VectorStruct &bond, int &index);
Real calcRestraintHessian(AtomStruct &Atom1, AtomStruct &Atom2, AtomStruct &Atom3, AtomStruct &Atom4);
Real calcRestraintHessian(AtomStruct &mobileAtom, AtomStruct &restraintAtom, AtomStruct &bondAtom1, AtomStruct &bondAtom2, VectorStruct &bond1, VectorStruct &bond2);
Real calcLocalMoveHessian(ProteinStruct &Protein, vector<AtomStruct> &restraintAtoms, vector<int> &restraintAtomsIndex, vector<int> &variableDihedrals, int &atom1, VectorStruct &bond1, int &index1, int &index2);
Real calcLocalMoveHessian(ProteinStruct &Protein, vector<AtomStruct> &restraintAtoms, vector<int> &restraintAtomsIndex, vector<int> variableDihedrals, int index1, int index2);
Real calcRestraintSecondDerivative(AtomStruct &Atom1, AtomStruct &Atom2);
Real calcRestraintSecondDerivative(AtomStruct &mobileAtom, AtomStruct &restraintAtom, AtomStruct &bondAtom, VectorStruct &bond);
Real calcLocalMoveSecondDerivative(ProteinStruct &Protein, vector<AtomStruct> &restraintAtoms, vector<int> &restraintAtomsIndex, vector<int> &variableDihedrals, int atom1, VectorStruct &bond, int &index);
void calcLocalMoveHessian(ProteinStruct &Protein, vector<AtomStruct> &restraintAtoms, vector<int> &restraintAtomsIndex, vector<int> &variableDihedrals, Real &derivative, Matrix &hessian, int &index);
void calcLocalMoveHessian(ProteinStruct &Protein, vector<AtomStruct> &restraintAtoms, vector<int> &restraintAtomsIndex, vector<int> &variableDihedrals, vector<Real> &gradient, Matrix &hessian);
void rotateToAllign(vector<AtomStruct> &Atoms, AtomStruct &restraintAtom, int &atomIndex, int &atom1, int &atom2);
void rotateToAllign(vector<AtomStruct> &Atoms, AtomStruct restraintAtom2, AtomStruct restraintAtom3, int &atomIndex, int &atom1, int &atom2);
Real optimizeAngle(ProteinStruct &Protein, vector<AtomStruct> &restraintAtoms, vector<int> &restraintAtomsIndex, vector<int> &variableDihedrals, int &index);
Real optimizeAnglesIndividually(ProteinStruct &Protein, vector<AtomStruct> &restraintAtoms, vector<Real> &dihedrals, vector<int> &restraintAtomsIndex, vector<int> &variableDihedrals);
Real localMoveHessian(ProteinStruct &Protein, int residue, int angleType, Real dAngle);
Real localMoveHessian(ProteinStruct &Protein, int residue, int angleType, Real dAngle);
Real localMoveHessian(ProteinStruct &Protein, vector<int> &restraintAtomsIndex, vector<int> variableDihedrals, int lastRestraintIndex, int lastDihedral, vector<AtomStruct> &restraintAtoms, AtomStruct &lastRestraintAtom);
Real localMoveHessianVeryFast(ProteinStruct &Protein, int residue, int angleType, Real dAngle);
#endif
