/*
    JV Library
    Copyright (C) 2014  Jouko Juhani Virtanen

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
# include <fstream>
# include <iostream>
# include <vector>
# include <algorithm>

using namespace std;

# include "Structures.h"
# include "IOUtils.h"

void printGro(string groFile, ProteinStruct &Protein)
{
	int natom=Protein.Atoms.size();
	ofstream file;
	
	OpenFileForWriting(groFile, file);

	file <<"Cool quote"<<endl;
	file <<natom<<endl;

	for (int i=0;i<natom;i++)
	{
		file <<setw(5)<<setiosflags(ios::right)
		<<Protein.Atoms[i].ResidueNum;
		file.unsetf(ios::right);
		file <<setw(6)<<resetiosflags(ios::left);
		file <<setiosflags(ios::left)<<Protein.Atoms[i].ResidueName;
		file.unsetf(ios::left);
		file <<setw(4)<<setiosflags(ios::right)
		<<Protein.Atoms[i].AtomName;
		file <<setw(5)<<Protein.Atoms[i].AtomNumber;
		file <<fixed;
		file <<setw(8)<<setprecision(3)<<Protein.Atoms[i].x*0.1;
		file <<setw(8)<<setprecision(3)<<Protein.Atoms[i].y*0.1;
		file <<setw(8)<<setprecision(3)<<Protein.Atoms[i].z*0.1<<endl;
	}
	file.unsetf(ios::right);
	file <<setw(10)<<setiosflags(ios::right)<<setprecision(5);
	file <<Protein.XBoxLength*0.1;
	file <<setw(10)<<setiosflags(ios::right)<<setprecision(5);
	file <<Protein.YBoxLength*0.1;
	file <<setw(10)<<setiosflags(ios::right)<<setprecision(5);
	file <<Protein.ZBoxLength*0.1;
}

