# include <iostream>
# include <vector>
# include <algorithm>

using namespace std;

# include "TypeDef.h"
# include "Structures.h"
# include "VectorManip.h"
# include "AtomUtils.h"
# include "MathUtils.h"
# include "Constants.h"
# include "HydrogenBond.h"
# include "SecondaryStructureAssignment.h"


bool isResHBond(vector< vector<int> > &hbonds, int res, int dist)
{
	int nhbond;
	int nres=hbonds.size();

	if (res<0 || res>=nres) return false;
	nhbond=hbonds[res].size();
	for (int i=0;i<nhbond;i++)
	{
		if (hbonds[res][i]==res+dist) return true;
	}
	return false;	
}

/*
bool isAntiparallelBridge(vector< vector<int> > &hbonds, int res)
{
	bool condition1, condition2, condition3;
	int nhbond;
	int nhbond2, nhbond3, nhbond4;
	int nres=hbonds.size();
	int res2, res3, res4;

	condition1=condition2=condition3=false;	
	if (res<0 || res>=nres) return false;
	nhbond=hbonds[res].size();
	for (int i=0;i<nhbond;i++)
	{
		if (abs(res-hbonds[res][i])>5)
		{
			res2=hbonds[res][i]-1;
			if (res2>=0 && res2<nres)
			{
				nhbond2=hbonds[res2].size();
				for (int j=0;j<nhbond2;j++)
				{
					if (hbonds[res2][j]==res+1) condition1=true;
				}
			}
			res3=res+1;
			if (res3>=0 && res3<nres)
			{
				nhbond3=hbonds[res3].size();
				for (int j=0;j<nhbond3;j++)
				{
					if (hbonds[res3][j]==res2+1) condition2=true;
				}
			}
			res4=res2+1;
			if (res4>=0 && res4<nres)
			{
				nhbond4=hbonds[res4].size();
				for (int j=0;j<nhbond4;j++)
				{
					if (hbonds[res4][j]==res+2) condition3=true;
				}
			}
			if (condition1 && condition2 && condition3) return true;
		}
	}
	return false;
}
*/
/*
bool isParallelBridge(vector< vector<int> > &hbonds, int res)
{
	bool condition1, condition2, condition3;
	int nhbond;
	int nhbond2, nhbond3, nhbond4;
	int nres=hbonds.size();
	int res2, res3, res4;

	condition1=condition2=condition3=false;	
	
	if (res<0 || res>=nres) return false;
	nhbond=hbonds[res].size();
	for (int i=0;i<nhbond;i++)
	{
		if (abs(res-hbonds[res][i])>5)
		{
			res2=hbonds[res][i];
			if (res2>=0 && res2<nres)
			{
				nhbond2=hbonds[res2].size();
				for (int j=0;j<nhbond2;j++)
				{
					if (hbonds[res2][j]==res) condition1=true;
				}
			}
			res3=res-1;
			if (res3>=0 && res3<nres)
			{
				nhbond3=hbonds[res3].size();
				for (int j=0;j<nhbond3;j++)
				{
					if (hbonds[res3][j]==res2-1) condition2=true;
				}
			}
			res4=res2-1;
			if (res4>=0 && res4<nres)
			{
				nhbond4=hbonds[res4].size();
				for (int j=0;j<nhbond4;j++)
				{
					if (hbonds[res4][j]==res-1) condition3=true;
				}
			}
			if (condition1 && condition2 && condition3) return true;
		}
	}
	return false;
}
*/

bool isParallelBridge(vector< vector<int> > &hbonds, int res)
{
	int nres=hbonds.size();
	int nhbond, nhbond2;
	int res2;

	cout <<"res= "<<res<<endl;
	if (res>0 && res<nres)
	{
		nhbond=hbonds[res-1].size();
		for (int i=0;i<nhbond;i++)
		{
			res2=hbonds[res-1][i];
			cout <<"res2= "<<res2<<endl;
			if (res2>=0 && res2<nres)
			{
				nhbond2=hbonds[res2].size();
				for (int j=0;j<nhbond2;j++)
				{
					cout <<"hbonds[res2][j]= "<<hbonds[res2][j]<<endl;
					if (hbonds[res2][j]==res+1) return true;
				}
			}
		}
		nhbond=hbonds[res].size();
		for (int i=0;i<nhbond;i++)
		{
			res2=hbonds[res][i]-2;
			cout <<"res2= "<<res2<<endl;
			if (res2>=0 && res2<nres)
			{
				nhbond2=hbonds[res2].size();
				for (int j=0;j<nhbond2;j++)
				{
					cout <<"hbonds[res2][j]= "<<hbonds[res2][j]<<endl;
					if (hbonds[res2][j]==res) return true;
				}
			}
		}
	}
	return false;
}

bool isAntiparallelBridge(vector< vector<int> > &hbonds, int res)
{
	int nres=hbonds.size();
	int nhbond, nhbond2;
	int res2;

	if (res>0 && res<nres)
	{
		nhbond=hbonds[res].size();
		for (int i=0;i<nhbond;i++)
		{
			res2=hbonds[res][i];
			if (res2>=0 && res2<nres)
			{
				nhbond2=hbonds[res2].size();
				for (int j=0;j<nhbond2;j++)
				{
					if (hbonds[res2][j]==res) return true;
				}
			}
		}
		nhbond=hbonds[res-1].size();
		for (int i=0;i<nhbond;i++)
		{
			res2=hbonds[res][i]-2;
			if (res2>=0 && res2<nres)
			{
				nhbond2=hbonds[res2].size();
				for (int j=0;j<nhbond2;j++)
				{
					if (hbonds[res2][j]==res+1) return true;
				}
			}
		}
	}
	return false;
}

int getSecondaryStructure(vector< vector<int> > &hbonds, int res)
{
	int nhbonds=hbonds[res].size();

	if (nhbonds==0) return UNSTRUCTURED;
	cout <<"res= "<<res<<endl;
	cout <<"isResHBond(hbonds, res, 3)= "<<isResHBond(hbonds, res, 3)<<endl;
	cout <<"isResHBond(hbonds, res+1, 3)= "<<isResHBond(hbonds, res+1, 3)<<endl;
	cout <<"isResHBond(hbonds, res, 4)= "<<isResHBond(hbonds, res, 4)<<endl;
	cout <<"isResHBond(hbonds, res+1, 4)= "<<isResHBond(hbonds, res+1, 4)<<endl;
	cout <<"isResHBond(hbonds, res, 5)= "<<isResHBond(hbonds, res, 5)<<endl;
	cout <<"isResHBond(hbonds, res+1, 5)= "<<isResHBond(hbonds, res+1, 5)<<endl;
	if (isResHBond(hbonds, res, 3) && isResHBond(hbonds, res+1, 3)) return HELIX_3;
	if (isResHBond(hbonds, res, 4) && isResHBond(hbonds, res+1, 4)) return ALPHA_HELIX;
	if (isResHBond(hbonds, res, 5) && isResHBond(hbonds, res+1, 5)) return HELIX_5;
	if (isResHBond(hbonds, res-1, 3) && isResHBond(hbonds, res, 3)) return HELIX_3;
	if (isResHBond(hbonds, res-1, 4) && isResHBond(hbonds, res, 4)) return ALPHA_HELIX;
	if (isResHBond(hbonds, res-1, 5) && isResHBond(hbonds, res, 5)) return HELIX_5;
	if (isResHBond(hbonds, res, 3)) return TURN;
	if (isResHBond(hbonds, res, 4)) return TURN;
	if (isResHBond(hbonds, res, 5)) return TURN;
	if (isAntiparallelBridge(hbonds, res)) return BETA_BRIDGE;	
	if (isParallelBridge(hbonds, res)) return BETA_BRIDGE;	

	return UNSTRUCTURED;
}

void assignSecondaryStructure(vector< vector<int> > &hbonds, vector<int> &secondaryStructure)
{
	int nres=hbonds.size();

	SafeAlloc(secondaryStructure, nres, "secondaryStructure");
	for (int i=0;i<nres-1;i++)
	{
		secondaryStructure[i]=getSecondaryStructure(hbonds, i);
	}
}

bool isResHBond(HydrogenBondingStruct &hBonding, int res, int dist)
{
	int diff;
	int nres=hBonding.nho1.size();
	Real cutoff=-0.5;

	if (res>=0 && res<nres)
	{
		if (hBonding.ohn1Energy[res]<cutoff)
		{
			diff=hBonding.ohn1[res]-res-1;
			if (diff==dist) return true;
		}
		if (hBonding.ohn2Energy[res]<cutoff)
		{
			diff=hBonding.ohn2[res]-res-1;
			if (diff==dist) return true;
		}
	}
	return false;
}

bool isResNHOBond(HydrogenBondingStruct &hBonding, int res, int dist)
{
	int diff;
	int nres=hBonding.nho1.size();
	Real cutoff=-0.5;

	if (res>=0 && res<nres)
	{
		if (hBonding.nho1Energy[res]<cutoff)
		{
			diff=hBonding.nho1[res]-res-1;
			if (diff==dist) return true;
		}
		if (hBonding.nho2Energy[res]<cutoff)
		{
			diff=hBonding.nho2[res]-res-1;
			if (diff==dist) return true;
		}
	}
	return false;
}

bool isHelix3(HydrogenBondingStruct &hBonding, int res)
{
	if (isResHBond(hBonding, res, 3) && isResHBond(hBonding, res+1, 3)) return true;
	if (isResHBond(hBonding, res, 3) && isResHBond(hBonding, res-1, 3)) return true;
	if (isResNHOBond(hBonding, res, -3) && isResNHOBond(hBonding, res+1, -3)) return true;
	if (isResNHOBond(hBonding, res, -3) && isResNHOBond(hBonding, res-1, -3)) return true;
	return false;
}

bool isAlphaHelix(HydrogenBondingStruct &hBonding, int res)
{
	if (isResHBond(hBonding, res, 4) && isResHBond(hBonding, res+1, 4)) return true;
	if (isResHBond(hBonding, res, 4) && isResHBond(hBonding, res-1, 4)) return true;
	if (isResNHOBond(hBonding, res, -4) && isResNHOBond(hBonding, res+1, -4)) return true;
	if (isResNHOBond(hBonding, res, -4) && isResNHOBond(hBonding, res-1, -4)) return true;
	return false;
}

bool isHelix5(HydrogenBondingStruct &hBonding, int res)
{
	if (isResHBond(hBonding, res, 5) && isResHBond(hBonding, res+1, 5)) return true;
	if (isResHBond(hBonding, res, 5) && isResHBond(hBonding, res-1, 5)) return true;
	if (isResNHOBond(hBonding, res, -5) && isResNHOBond(hBonding, res+1, -5)) return true;
	if (isResNHOBond(hBonding, res, -5) && isResNHOBond(hBonding, res-1, -5)) return true;
	return false;
}

bool isTurn(HydrogenBondingStruct &hBonding, int res)
{
	int diff;
	int nres=hBonding.nho1.size();
	Real cutoff=-0.5;

	if (res>=0 && res<nres)
	{
		if (hBonding.nho1Energy[res]<cutoff)
		{
			diff=hBonding.nho1[res]-res-1;
			if (diff>=3 && diff<=5) return true;
		}
		if (hBonding.nho2Energy[res]<cutoff)
		{
			diff=hBonding.nho2[res]-res-1;
			if (diff>=3 && diff<=5) return true;
		}
	}
	return false;
	
}

bool isAntiparallelBridge(HydrogenBondingStruct &hBonding, int res)
{
	bool boolPrint=false;
	int res2;
	Real cutoff=-0.5;

	if (res==11) boolPrint=true;
	if (res>=0 && hBonding.ohn1Energy[res]<cutoff)
	{
		res2=hBonding.ohn1[res];
		if (res2>=1 && hBonding.ohn1Energy[res2-1]<cutoff)
		{
			if (boolPrint) printLocation(__LINE__, __FILE__);
			if (hBonding.ohn1[res2-1]==res+1) return true;
		}
	}

	if (res>=1 && hBonding.ohn1Energy[res-1]<cutoff)	
	{
		res2=hBonding.ohn1[res-1]-2;
		//cout <<"res= "<<res<<" hBonding.ohn1[res-1]= "<<hBonding.ohn1[res-1]<<" res2= "<<res2<<" hBonding.ohn1[res2-1]= "<<hBonding.ohn1[res2-1]<<endl;
		if (res2>=1 && hBonding.ohn1Energy[res2-1]<cutoff)
		{
			if (boolPrint) printLocation(__LINE__, __FILE__);
			if (hBonding.ohn1[res2-1]==res+2) return true;
		}
	}
	return false;
}

bool isParallelBridge(HydrogenBondingStruct &hBonding, int res)
{
	bool boolPrint=false;
	int res2;
	Real cutoff=-0.5;

	if (res==11) boolPrint=true;
	if (res>=-1 && hBonding.ohn1Energy[res-1]<cutoff)
	{
		res2=hBonding.ohn1[res-1];
		//cout <<"res= "<<res<<" res2= "<<res2<<" hBonding.ohn1[res2-1]= "<<hBonding.ohn1[res2-1]<<endl;
		if (res2>=1 && hBonding.ohn1Energy[res2-1]<cutoff)
		{
			if (hBonding.ohn1[res2-1]==res+2) 
			{
				if (boolPrint) printLocation(__LINE__, __FILE__);
				return true;
			}
		}
	}

	if (res>=0 && hBonding.ohn1Energy[res]<cutoff)	
	{
		res2=hBonding.ohn1[res]-2;
		if (res2>=1 && hBonding.ohn1Energy[res2-1]<cutoff)
		{
			if (hBonding.ohn1[res2-1]==res+1) 
			{
				if (boolPrint) printLocation(__LINE__, __FILE__);
				return true;
			}
		}
	}
	return false;
}

int getSecondaryStructure(HydrogenBondingStruct &hBonding, int res)
{
	if (isAlphaHelix(hBonding, res)) return ALPHA_HELIX;
	if (isAntiparallelBridge(hBonding, res)) return BETA_BRIDGE;	
	if (isParallelBridge(hBonding, res)) return BETA_BRIDGE;	
	if (isHelix3(hBonding, res)) return HELIX_3;
	if (isHelix5(hBonding, res)) return HELIX_5;
	if (isTurn(hBonding, res)) return TURN;

	return UNSTRUCTURED;
}

void assignSecondaryStructure(HydrogenBondingStruct &hBonding, vector<int> &secondaryStructure)
{
	int nres=hBonding.nho1.size();

	SafeAlloc(secondaryStructure, nres, "secondaryStructure");
	for (int i=0;i<nres-1;i++)
	{
		secondaryStructure[i]=getSecondaryStructure(hBonding, i);
	}
}

void findBends(ProteinStruct &Protein, vector<int> &secondaryStructure)
{
	int nres=secondaryStructure.size();
	int atom1, atom2, atom3;
	Real angle, cutoff=110.0;

	for (int i=2;i<nres-2;i++)
	{
		atom1=getAtomIndex(Protein.Atoms, i-2, "C");
		atom2=getAtomIndex(Protein.Atoms, i, "C");
		atom3=getAtomIndex(Protein.Atoms, i+2, "C");
		if (atom1!=UNK_INT && atom2!=UNK_INT && atom3!=UNK_INT && secondaryStructure[i-1]==UNSTRUCTURED)
		{
			angle=calcAngle(Protein.Atoms, atom1, atom2, atom3);
			angle*=RAD_TO_DEGREE;
			angle=180.0-angle;
			cout <<"angle= "<<angle<<endl;
			if (angle<cutoff) secondaryStructure[i-1]=BEND;
		}
	}
}

void consecutiveBridgesToExtended(vector<int> &secondaryStructure)
{
	int nres=secondaryStructure.size();

	cout <<"In consecutiveBridgesToExtended"<<endl;
	if (secondaryStructure[0]==BETA_BRIDGE && secondaryStructure[1]==BETA_BRIDGE)
	{
		secondaryStructure[0]=STRAND;
	}
	if (secondaryStructure[0]==BETA_BRIDGE && secondaryStructure[1]==STRAND)
	{
		secondaryStructure[0]=STRAND;
	}

	for (int i=1;i<nres-1;i++)
	{
		if (secondaryStructure[i]==BETA_BRIDGE && secondaryStructure[i-1]==BETA_BRIDGE)
		{
			secondaryStructure[i]=STRAND;
		}
		if (secondaryStructure[i]==BETA_BRIDGE && secondaryStructure[i-1]==STRAND)
		{
			secondaryStructure[i]=STRAND;
		}
		if (secondaryStructure[i]==BETA_BRIDGE && secondaryStructure[i+1]==BETA_BRIDGE)
		{
			secondaryStructure[i]=STRAND;
		}
		if (secondaryStructure[i]==BETA_BRIDGE && secondaryStructure[i+1]==STRAND)
		{
			secondaryStructure[i]=STRAND;
		}
	}

	if (secondaryStructure[nres-1]==BETA_BRIDGE && secondaryStructure[nres-2]==BETA_BRIDGE)
	{
		secondaryStructure[nres-1]=STRAND;
	}
	if (secondaryStructure[nres-1]==BETA_BRIDGE && secondaryStructure[nres-2]==STRAND)
	{
		secondaryStructure[nres-1]=STRAND;
	}
}

void assignSecondaryStructure(ProteinStruct &Protein, HydrogenBondingStruct &hBonding, vector<int> &secondaryStructure)
{
	findHydrogenBondingNetwork(Protein, hBonding);
	assignSecondaryStructure(hBonding, secondaryStructure);
	consecutiveBridgesToExtended(secondaryStructure);
	findBends(Protein, secondaryStructure);
}

void assignSecondaryStructure(ProteinStruct &Protein, vector<int> &secondaryStructure)
{
	vector< vector<int> > hbonds;

	cout <<"Before findHBonds"<<endl;
	findHBonds(Protein, hbonds);
	cout <<"Before assignSecondaryStructure"<<endl;
	assignSecondaryStructure(hbonds, secondaryStructure);
	consecutiveBridgesToExtended(secondaryStructure);
	cout <<"Before findBends"<<endl;
	findBends(Protein, secondaryStructure);
}
