/*
    JV Library
    Copyright (C) 2014  Jouko Juhani Virtanen

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _TMScore_include_
#define _TMScore_include_
Real TMScoreNoAlign(vector<AtomStruct> &Atoms1, vector<AtomStruct> &Atoms2);
Real TMScoreNoAlignAll(vector<AtomStruct> &Atoms1, vector<AtomStruct> &Atoms2);
Real EvaluateOrientation(vector<AtomStruct> Atoms1, vector<AtomStruct> Atoms2, Real theta, Real phi, Real psi);
void Rotate(vector<AtomStruct> &Atoms, Real step, int RotationType);
Real CalcDerivative(vector<AtomStruct> Atoms1, vector<AtomStruct> Atoms2, Real step, int RotationType, Real theta, Real phi, Real psi);
Real CalcGradient(vector<AtomStruct> Atoms1, vector<AtomStruct> Atoms2, Real derivative[3], Real theta, Real phi, Real psi);
Real GridSearch(vector<AtomStruct> Atoms1, vector<AtomStruct> Atoms2, Real &theta, Real &phi, Real &psi);
void GetStep(Real derivative[], Real step[], Real TotalStep);
Real MinimizeAlongVector(vector<AtomStruct> Atoms1, vector<AtomStruct> Atoms2, Real derivative[], Real &theta, Real &phi, Real &psi);
Real calcTMScore(vector<AtomStruct> &Atoms1, vector<AtomStruct> &Atoms2, string TMScoreType, Real &theta, Real &phi, Real &psi, Real &dx, Real &dy, Real &dz);
Real calcTMScore(vector<AtomStruct> &Atoms1, vector<AtomStruct> &Atoms2, string TMScoreType);
Real calcTMScore(vector<AtomStruct> &Atoms1, vector<AtomStruct> &Atoms2);
Real calcTMScore_CA(vector<AtomStruct> Atoms1, vector<AtomStruct> Atoms2);
Real calcTMScore_CA(string pdbFile, vector<AtomStruct> Atoms2);
#endif
